// Listado.
// Declaracion

#include <math.h>

Boton *B_on_off;
Boton *Bcmd0;
Boton *Bcmd1;
Boton *Bcmd2;
Boton *Bcmd3;
Boton *Bcmd4;
Boton *Bcmd5;
Boton *Bcmd6;
Boton *Bcmd7;
Boton *Bcmd8;
Boton *Bcmd9;

Boton *BIgual;
Boton *BDIV;
Boton *BPor;
Boton *BMenos;
Boton *BMas;
Boton *BC;
Boton *BCA;
Boton *Bmasmenos;
Boton *BMmas;
Boton *BMmenos;
Boton *BMR;
Boton *BPunto;
Boton *BRaiz;
Boton *BCiento;

TextoE *lcd0;
TextoS *lcd0S;
char tmp[24];

//imprime con alineamento a la derecha.
void printLCD(char *s)
{
 char linea[17];
 int z,z1;
	linea[16]=0;
	z1=strlen(s);
	for(z=15;z>=0;z--,z1--)
	 {
	  linea[z]=s[z1];
	  if(z1<0) linea[z]=32;
	 }
	//printf("%s\n",linea);
	//lcd0->Text((char*) linea);
	lcd0S->Text((char*) linea);
	Repaint();
}

void setDisplay(void)
{
	long z,z1;
	 if(Ferror==True)
		{
		  lcd0->Text((char*)"Error");
		  return;
		}
		z=DISPLAY;
		z1=(DISPLAY-z)*1000;
	  if(z1==0)
	  {
		sprintf(tmp,"%li",z);
	  }
	  else
	  {
		if(z1<0) z1*=-1;
		sprintf(tmp,"%li.%03li",z,z1);
	  }
	  //printf("%d,%d\n",z,z1);
	  //sprintf(tmp,"%.3f",DISPLAY);
	  //printf("%f\n",DISPLAY);
	  printLCD(tmp);
}

void insertar(char c)
{
	if(Ferror==True) return;
	if (caracteres>10) return;
	if(caracteres==0)
		{
		 sprintf(LCD,"%c",c);	
		}
		else
		{
		 sprintf(tmp,"%s%c",LCD,c);
		 strncpy(LCD,tmp,19);
		}
	caracteres++;	
	DISPLAY=atof(LCD);
	printLCD(LCD);
}


void calculo(void)
{
	switch(Fcomando)
	{
		case '+':
			DISPLAY=DISPLAY+ACUMULADOR;
			setDisplay();
		break;
		case '-':
			DISPLAY=ACUMULADOR-DISPLAY;
			setDisplay();
		break;
		case '*':
			DISPLAY=ACUMULADOR*DISPLAY;
			setDisplay();
		break;
		case '/':
			if(DISPLAY==0)
			{
			 Ferror=True;
			 lcd0->Text((char*) "Infinite");
			}
			else
			{
			 DISPLAY=ACUMULADOR/DISPLAY;
			 setDisplay();
			}
		break;
		case '%':
			switch(Fciento)
				{
					case '*':
					break;
					case '+':
						DISPLAY=ACUMULADOR+DISPLAY;
					break;
					case '-':
						DISPLAY=ACUMULADOR-DISPLAY;
					break;
				}
			setDisplay();
		break;
	}
	Fcomando=0;
}

void precalculo(void)
{
	if(Fcomando!=0) calculo();	
	ACUMULADOR=DISPLAY;
	DISPLAY=0;
	Fpunto=False;
	caracteres=0;switch(Fciento)
				{
					case '*':
					break;
					case '+':
						DISPLAY=ACUMULADOR+DISPLAY;
					break;
					case '-':
						DISPLAY=ACUMULADOR-DISPLAY;
					break;
				}
}

// Funciones
void Fun_on_off(void) { printf("END\n"); Fquit=1; }
void Funcmd0(void) { insertar('0');}
void Funcmd1(void) { insertar('1');}
void Funcmd2(void) { insertar('2');}
void Funcmd3(void) { insertar('3');}
void Funcmd4(void) { insertar('4');}
void Funcmd5(void) { insertar('5');}
void Funcmd6(void) { insertar('6');}
void Funcmd7(void) { insertar('7');}
void Funcmd8(void) { insertar('8');}
void Funcmd9(void) { insertar('9');}

void FunIgual(void) 
	{
	 if(Ferror==True) return;	  	
	 calculo();	
	}	
void FunDIV(void) 
	{ 
	 if(Ferror==True) return;
	 precalculo();	Fcomando='/';
	}
void FunPor(void) 
	{ 
	 if(Ferror==True) return;
	 precalculo();	Fcomando='*';
	}

void FunMenos(void) 
	{
	 if(Ferror==True) return;		
	  if(Fcomando=='%')
		{
			 DISPLAY=ACUMULADOR-DISPLAY;
			 setDisplay();
			 Fcomando=0;
			 return;
		}
	 precalculo();	Fcomando='-'; 
	}
	
void FunMas(void) 	
	{
	 if(Ferror==True) return;		
	 if(Fcomando=='%')
		 {
			 DISPLAY=DISPLAY+ACUMULADOR;
			 setDisplay();
			 Fcomando=0;
			 return;
		 } 
	 precalculo();	Fcomando='+';	
	}
	

void FunPunto(void) 
	{
		if(Ferror==True) return;		
		if(Ferror==True) return;
		if(Fpunto==False)
		{
		 insertar('.');
		 Fpunto=True;
		}
	}
	
void FunRaiz(void) 
	{
	 if(Ferror==True) return;
	 if(DISPLAY<0) 
		{
			Ferror=True;
			lcd0->Text((char*) "Error SQRT -");
		}
	if(Ferror==True) return;
	DISPLAY=sqrt(DISPLAY);
	setDisplay();
	}
	
void FunCiento(void) 
	{ 
	 if(Ferror==True) return;
		//printf("E_Ciento\n");
		switch(Fcomando)
				{
					case '*':
						DISPLAY=(ACUMULADOR*DISPLAY)/100;
						Fciento='*';
						setDisplay();
					break;
					case '+':
						DISPLAY=(ACUMULADOR*DISPLAY)/100;
						Fciento='+';
						setDisplay();
					break;
					case '-':
						DISPLAY=(ACUMULADOR*DISPLAY)/100;
						Fciento='-';
						setDisplay();
					break;
				}
		Fcomando='%';	
	}



void Funlcd0(void) {printf("E_Etext1\n"); }


void FunCA(void) 
	{ 
	  printLCD((char*)"0");
	  Fpunto = False;
	  caracteres = 0;
	  DISPLAY = 0;
	  ACUMULADOR = 0;
	  Ferror = False;
	  Fciento = 0;
	  Fcomando = 0;
	}

void FunC(void) 
	 { 
	  printLCD((char*)"0");
	  Fpunto = False;
	  caracteres = 0;
	  DISPLAY = 0;
	  //ACUMULADOR = 0;
	  Ferror = False;
	  //Fciento = 0;
	  //Fcomando = 0;
	 }
 
void FunMR(void) 
	{ 
	 DISPLAY=MEMORIA;
	 setDisplay();
	 printf("memoria=%f\n",MEMORIA);
	}
void FunMmas(void) 
	{ 
	 MEMORIA=MEMORIA+DISPLAY;
	 printf("memoria=%f\n",MEMORIA);
	}
void FunMmenos(void) 
	{ 
	 MEMORIA=MEMORIA-DISPLAY;
	 printf("memoria=%f\n",MEMORIA);
	}
void Funmasmenos(void) 
	{ 
	 DISPLAY=DISPLAY*-1;
	 setDisplay();
	}

// Creacion
void Creacion(void) 
{
	B_on_off=new Boton(0,70,40,35,(char*)"on"); 
	Bcmd0=new Boton(45,432,40,26,(char*)"0"); 
	Bcmd1=new Boton(45,387,40,26,(char*)"1"); 
	Bcmd2=new Boton(108,387,40,26,(char*)"2"); 
	Bcmd3=new Boton(171,387,40,26,(char*)"3"); 
	Bcmd4=new Boton(45,333,40,26,(char*)"4"); 
	Bcmd5=new Boton(108,333,40,26,(char*)"5"); 
	Bcmd6=new Boton(171,333,40,26,(char*)"6"); 
	Bcmd7=new Boton(45,288,40,26,(char*)"7"); 
	Bcmd8=new Boton(108,288,40,26,(char*)"8"); 
	Bcmd9=new Boton(171,288,40,26,(char*)"9"); 

	BIgual=new Boton(171,432,40,26,(char*)"ig"); 
	BDIV=new Boton(234,288,40,26,(char*)"/"); 
	BPor=new Boton(234,333,40,26,(char*)"X"); 
	BMenos=new Boton(234,387,40,26,(char*)"-"); 
	BMas=new Boton(234,432,40,26,(char*)"+"); 	
	BPunto=new Boton(108,432,40,26,(char*)"pu"); 
	BRaiz=new Boton(171,189,40,26,(char*)"sqr"); 
	BCiento=new Boton(234,189,40,26,(char*)"cie"); 
	
	BC=new Boton(110,189,40,26,(char*)"C"); 
	BCA=new Boton(45,189,40,26,(char*)"CA");
	Bmasmenos=new Boton(51,235,40,26,(char*)"+/-");
	BMmas=new Boton(235,235,40,26,(char*)"M+");
	BMmenos=new Boton(173,235,40,26,(char*)"M-");
	BMR=new Boton(110,235,40,26,(char*)"MR");

	lcd0=new TextoE(63,9,234,32,(char*)"TextoE1"); 
	lcd0S=new TextoS(63,99,(char*)"TextoE1S"); 


	Bcmd0->Visible(0); Bcmd1->Visible(0); Bcmd2->Visible(0); Bcmd3->Visible(0); Bcmd4->Visible(0);
	Bcmd5->Visible(0); Bcmd6->Visible(0); Bcmd7->Visible(0); Bcmd8->Visible(0); Bcmd9->Visible(0); 

	BIgual->Visible(0); BDIV->Visible(0); BPor->Visible(0); BMenos->Visible(0); 
	BMas->Visible(0); BC->Visible(0); BPunto->Visible(0); BRaiz->Visible(0); BCiento->Visible(0); 
	B_on_off->Visible(0); 
	BCA->Visible(0); Bmasmenos->Visible(0); BMR->Visible(0); BMmas->Visible(0); BMmenos->Visible(0);
}

// Eventos
void Eventos(void) 
{
	if(B_on_off->get(mouse_x,mouse_y)) { Fun_on_off(); goto saltoEvento; }
	if(Bcmd0->get(mouse_x,mouse_y)) { Funcmd0();goto saltoEvento; }
	if(Bcmd1->get(mouse_x,mouse_y)) { Funcmd1();goto saltoEvento; }
	if(Bcmd2->get(mouse_x,mouse_y)) { Funcmd2();goto saltoEvento; }
	if(Bcmd3->get(mouse_x,mouse_y)) { Funcmd3(); goto saltoEvento; }
	if(Bcmd4->get(mouse_x,mouse_y)) { Funcmd4(); goto saltoEvento; }
	if(Bcmd5->get(mouse_x,mouse_y)) { Funcmd5(); goto saltoEvento; }
	if(Bcmd6->get(mouse_x,mouse_y)) { Funcmd6(); goto saltoEvento; }
	if(Bcmd7->get(mouse_x,mouse_y)) { Funcmd7(); goto saltoEvento; }
	if(Bcmd8->get(mouse_x,mouse_y)) { Funcmd8(); goto saltoEvento; }
	if(Bcmd9->get(mouse_x,mouse_y)) { Funcmd9(); goto saltoEvento; }

	if(BIgual->get(mouse_x,mouse_y)) { FunIgual(); goto saltoEvento; }
	if(BDIV->get(mouse_x,mouse_y)) { FunDIV(); goto saltoEvento; }
	if(BPor->get(mouse_x,mouse_y)) { FunPor(); goto saltoEvento; }
	if(BMenos->get(mouse_x,mouse_y)) { FunMenos(); goto saltoEvento; }
	if(BMas->get(mouse_x,mouse_y)) { FunMas(); goto saltoEvento; }
	if(BC->get(mouse_x,mouse_y)) { FunC(); goto saltoEvento; }
	if(BCA->get(mouse_x,mouse_y)) { FunCA(); goto saltoEvento; }
	if(BPunto->get(mouse_x,mouse_y)) { FunPunto(); goto saltoEvento; }
	if(BRaiz->get(mouse_x,mouse_y)) { FunRaiz(); goto saltoEvento; }
	if(BCiento->get(mouse_x,mouse_y)) { FunCiento(); goto saltoEvento; }
	if(Bmasmenos->get(mouse_x,mouse_y)) { Funmasmenos(); goto saltoEvento; }
	
	if(BMR->get(mouse_x,mouse_y)) { FunMR(); goto saltoEvento; }
	if(BMmas->get(mouse_x,mouse_y)) { FunMmas(); goto saltoEvento; }
	if(BMmenos->get(mouse_x,mouse_y)) { FunMmenos(); goto saltoEvento; }
	
	printf("No eventos\n");
saltoEvento:
	;
	//if(lcd0->get(mouse_x,mouse_y)) Funlcd0();
}

// Redibujado
void Redibujado(void) 
{
	B_on_off->Dibujar();
	Bcmd0->Dibujar();
	Bcmd1->Dibujar();
	Bcmd2->Dibujar();
	Bcmd3->Dibujar();
	Bcmd4->Dibujar();
	Bcmd5->Dibujar();
	Bcmd6->Dibujar();
	Bcmd7->Dibujar();
	Bcmd8->Dibujar();
	Bcmd9->Dibujar();

	BIgual->Dibujar();

	BDIV->Dibujar();
	BPor->Dibujar();
	BMenos->Dibujar();
	BMas->Dibujar();
	BC->Dibujar();
	BPunto->Dibujar();
	BRaiz->Dibujar();
	BCiento->Dibujar();
	
	BCA->Dibujar();
	Bmasmenos->Dibujar();
	BMmas->Dibujar();
	BMmenos->Dibujar();
	BMR->Dibujar();

	//lcd0->Dibujar();
	setcolor(133,248,73);
	lcd0S->DibujarColor();
}


void keyFun(int t)
{
	switch(t)
		{
			case 13:
				FunIgual();
				break;
			case 271:
				FunIgual();
				break;
			case 8:
				FunC();
				break;
			case 127:
				FunC();
				break;
			case 256:
				Funcmd0();
				break;
			case 48:
				Funcmd0();
				break;
			case 257:
				Funcmd1();
				break;
			case 49:
				Funcmd1();
				break;
			case 258:
				Funcmd2();
				break;
			case 50:
				Funcmd2();
				break;
			case 259:
				Funcmd3();
				break;
			case 51:
				Funcmd3();
				break;
			case 260:
				Funcmd4();
				break;
			case 52:
				Funcmd4();
				break;
			case 261:
				Funcmd5();
				break;
			case 53:
				Funcmd5();
				break;
			case 262:
				Funcmd6();
				break;
			case 54:
				Funcmd6();
				break;
			case 263:
				Funcmd7();
				break;
			case 55:
				Funcmd7();
				break;
			case 264:
				Funcmd8();
				break;
			case 56:
				Funcmd8();
				break;
			case 265:
				Funcmd9();
				break;
			case 57:
				Funcmd9();
			break;
			
			case 266:
				FunPunto();
				break;
			case 46:
				FunPunto();
				break;
				
			case 270:
				FunMas();
				break;
			case 43:
				FunMas();
				break;
			case 269:
				FunMenos();
				break;
			case 45:
				FunMenos();
			break;
			case 268:
				FunPor();
				break;
			case 267:
				FunDIV();
				break;			
		}
}
