#include <unistd.h>

#include <time.h>
#include <SDL/SDL.h>
#include "SDL/SDL_ttf.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_mixer.h"

#include "main.h"
#include "xgrafi.h"
#include "objetos.h"


void Repaint(void);
void MiTimer();
#define TIEMPO1		25
#define TIEMPO2		50
#define TIEMPO3		100
int tiempo1=TIEMPO1,tiempo2=TIEMPO2, tiempo3=TIEMPO3;
int mouse_x,mouse_y;
int pantaX=314,pantaY=501;
int Fquit = 0;

int segundos=0;

#define True 1
#define False 0


bool Fpunto,Ferror;
char Fcomando,Fciento;

int caracteres;
float ACUMULADOR,DISPLAY,MEMORIA;

char LCD[20];

#include "entorno.h"

int main (int argc, char *argv[])
{		
	int SimbolKey;
	//Uint8 *teclas; 
			
	if(init(pantaX,pantaY) == 0 ) return 1;	
	SDL_FillRect( screen, NULL, SDL_MapRGB( screen->format, 0xaa, 0xaa, 0xaa ) );
	if( SDL_Flip( screen ) == -1 ) return 3;
	if (load_files((char*)"casioA1.png",NULL,(char*)"fontlcd.ttf") == 0 ) return 2;
	//if (load_files((char*)"casioA1.png",NULL,(char*)"setam.ttf") == 0 ) return 2;
	//if (load_files(NULL,NULL,(char*)"setam.ttf") == 0 ) return 2;

//_______________________	

	Creacion();
	
	FunC();
	Repaint();	
//________________________		
	
	while( Fquit == 0 )
	{	
		SDL_Delay(10);	  
		MiTimer();								  	  
		while( SDL_PollEvent( &event ) )
		{
			//teclas = SDL_GetKeyState(NULL);			
			switch (event.type)			
			{				
				case	SDL_KEYDOWN:
						SimbolKey=event.key.keysym.sym;
						
						#ifdef DEBUG 
							printf("Evento Tecla SimbolKey=%d \n",SimbolKey);
						#endif	
						keyFun(SimbolKey);									
						switch (SimbolKey)			
							{	
								/*			
								case	SDLK_F1:
										#if YesWindows
											screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,SDL_FULLSCREEN | SDL_SWSURFACE );
										#else
											SDL_WM_ToggleFullScreen(screen);
										#endif  
										Repaint();						
								break;
								case	SDLK_F2:
										screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE );						
										Repaint();
								break;
								*/
								case	SDLK_ESCAPE:
										Fquit=1;
								break;
								case	SDLK_r:
										Repaint();
								break;							
							}					
				break;
				
				case	SDL_MOUSEBUTTONDOWN:
						mouse_x=event.button.x;
						mouse_y=event.button.y;				
						#ifdef DEBUG 
							printf("Evento Raton Abajo X=%d Y=%d Nboton=%d\n",mouse_x,mouse_y,event.button.button);	
						#endif
						
						if(event.button.button==1) 	 { }
						if(event.button.button==2)	 { }
						if(event.button.button==3)	 { }
												
						goto salir12;						
						SDL_Flip( screen );
salir12:
				break;
				
				case	SDL_MOUSEBUTTONUP:
						mouse_x=event.button.x;
						mouse_y=event.button.y;
						if(event.button.button==1) 	 {	Eventos();	 }
						if(event.button.button==2)	 { }
						if(event.button.button==3)	 { }
						Repaint();									
						#ifdef DEBUG 
							printf("Boton Arriba X=%d Y=%d \n",mouse_x,mouse_y);
						#endif	
				break;
				
				case	SDL_QUIT:
					Fquit = 1;
				break;		
			}			
		}
	}
		
//Cerrar todo el SDL
	clean_up();
	#ifdef DEBUG 
		printf("Fin\n");
	#endif	
	SDL_Delay(500);
	return 0;  
}


void Repaint(void)
{
	//SDL_FillRect( screen, NULL, SDL_MapRGB( screen->format, 0xaa, 0xaa, 0xaa ) );
	apply_surface( 0, 0, background, screen );
	Redibujado();
	SDL_Flip( screen );
}


//____________________FIN____________

void MiTimer()
{
 tiempo1--;		tiempo2--;		tiempo3--;
 if( tiempo1<0)
     { tiempo1=TIEMPO1;}
 if( tiempo2<0)
     { tiempo2=TIEMPO2;}
 if( tiempo3<0)
     { 
	  tiempo3=TIEMPO3;
	  segundos++;	  
//	  Repaint();
	 }
				
}


 
